import turtle
import math
import time
import random

t = turtle.Turtle()
def flowers(size, t):   #制作尺寸为size的樱花
    col = (int(c) for c in t.pencolor())
    width = t.pensize()
    turtle.colormode(255)
    t.pencolor(105, 105, 105)   #深灰色描边
    t.fillcolor(255,192,203)    #粉色
    t.pensize(1)
    t.penup()
    t.forward(size)
    t.pendown()
    t.begin_fill()
    for i in range(5):  #画出花瓣
        t.circle(size * math.tan(math.pi / 5), 252)
        t.left(180)
    t.end_fill()
    t.penup()
    t.backward(size)
    t.pendown()
    t.pencolor(255,0, 0)    #大红色花蕊
    for i in range(6):  #绘制六朵花蕊
        ang = random.randrange(0, 60)
        t.left(ang)
        t.forward(2 * size / 3)
        t.pensize(2)
        t.forward(1)
        t.backward(1)
        t.pensize(1)
        t.backward(2 * size / 3)
        t.left(60 - ang)
    t.pensize(width)    #将海龟变回原来的参数
    t.pencolor(col)

def tree(lenth, width, ang, t): #主程序
    if lenth < 10:  #如果枝叶过小，就绘制花蕊
        flowers(lenth /2, t)
    else:
        turtle.colormode(255)
        t.pencolor(210,105,30)  #巧克力色树干
        t.pensize(width)
        if ang: #当倾角不为0的时候，以圆弧的方式转弯
            t.circle(lenth /(2 *math.sin(ang * math.pi /180)), abs(ang) * 2)
        else:   #当倾角为0的时候（仅在树干的情况下会用到）直接走直线
            t.forward(lenth)
        llenth = (random.random() + 1) /2 *lenth    #向左的分支，长度在原来的1/2到1之间随机取值
        lang = random.randrange(5, 25)  #倾角在5到25度之间
        tree(llenth, width / math.sqrt(2), lang, t) #宽度为原来的宽度除以根号2
        rlenth = (random.random() + 1) /2 *lenth
        rang = random.randrange(-25, -5)
        tree(rlenth, width / math.sqrt(2), rang, t)
        t.left(180) #绘制完分支之后，返回原处
        if ang:
            t.circle(-lenth /(2 *math.sin(ang * math.pi / 180)), abs(ang) * 2)
        else:
            t.forward(lenth)
        t.left(180)

t = turtle.Turtle()
t.speed(0)
t.screen.delay(0)
win = turtle.Screen()
turtle.bgcolor("Black") #黑色背景
t.penup()
t.goto(400, -400)   #在画布右下角开始
t.pendown()
t.left(90)
tree(80, 14, 0, t) #初始倾角为0画出树干
t.penup()
t.goto(400, 400)   #在画布右下角开始
t.pendown()
t.setheading(90)
tree(80, 14, 0, t) #初始倾角为0画出树干
win.exitonclick()