import pygame
pygame.init()

class Sprite():
    image = None
    position = None
    visible = False # show() will not work when invisible

    def __init__(self,pos = (0,0)):
        self.image = None
        self.position = pos
        self.visible = False

    def loadImage(self,address):	#set the sprite's image from file
        self.image = pygame.image.load(address)

    def setImage(self,surface):		#set the sprite's image from pygame.surface
        self.image = surface

    def move(self,vector2):
        self.position = (self.position[0]+vector2[0],self.position[1]+vector2[1])

    def setPosition(self,vector2):
        self.position = vector2

    def show(self,screen):			#only shows it on the given surface, display need to be updated manually
        if self.visible:
            screen.blit(self.image,self.position)