import pygame
import math
pygame.init()

class SnowPainter():    # this records every line on the curve and does the recursion by spawning childs of itself
    start = None
    end = None
    def __init__(self,startPoint = (0,0),endPoint = (0,0)):
        self.start = startPoint
        self.end = endPoint

    def show(self,screen,color):
        pygame.draw.line(screen,color,self.start,self.end,1)

    def deepIn(self):
        xa = self.start[0]
        xb = self.end[0]
        ya = self.start[1]
        yb = self.end[1]
        d = 1/(2*math.sqrt(3))
        p0 = self.start
        p1 = (int((2 * xa + xb) / 3), int((2 * ya + yb) / 3))
        p2 = ((int(xa+xb)/2-(ya-yb)*d),int((ya+yb)/2-(xb-xa)*d))
        p3 = (int((xa + 2 * xb) / 3), int((ya + 2 * yb) / 3))
        p4 = self.end
        s1 = SnowPainter(p0, p1)
        s2 = SnowPainter(p1, p2)
        s3 = SnowPainter(p2, p3)
        s4 = SnowPainter(p3, p4)
        return [s1,s2,s3,s4]
                                    # every line will generate four child  lines
pygame.display.set_mode((1200,800))
pygame.display.set_caption('H5-snow')
canvas = pygame.display.get_surface()
blackBG = canvas.copy()
SnowZero = SnowPainter((50,600),(1150,600))
SnowZero.show(canvas,(255,255,255))
#display initialization
snowList = [] # a list for all lines
layer = 0
lineColor = pygame.Color(0)
snowList.append(SnowZero)
pygame.display.flip()
while True:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit() #Input detection
        if pygame.key.get_pressed()[pygame.K_SPACE] and layer <= 6: # recursion once when [SPACE] is pressed
            nextList = []
            for snowPainter in snowList:
                for newPainter in snowPainter.deepIn():
                    nextList.append(newPainter)
                                                        # up to 6 layers because 7+ layers will take too long to display
            snowList = nextList
            canvas.blit(blackBG,(0,0))
            for snowPainter in snowList:
                lineColor.hsla = (int(snowList.index(snowPainter)*360/len(snowList)),100,50,100)
                snowPainter.show(canvas,lineColor)

            pygame.display.flip()
            layer += 1

        if pygame.key.get_pressed()[pygame.K_RETURN]:   # reset the display when [RETURN] is pressed
            snowList = [SnowZero]
            canvas.blit(blackBG, (0, 0))
            SnowZero.show(canvas,(255,255,255))
            pygame.display.flip()
            layer = 0


# HOW TO USE:
# Press Space to load the next level of the curve
# Press Enter to reset the curve