import pygame
import os
pygame.init()

fontSAO = pygame.font.Font(os.path.join('','SAOUI.ttf'),30)
# font SAOUI.ttf from SAO Utils
WindowWidth = 1400
WindowHeight = 800
pygame.display.set_mode((WindowWidth,WindowHeight))
canvas = pygame.display.get_surface()
bg = canvas.copy()
#display initialization
def printNum(str,posx,posy): # print a number at the given position
    canvas.blit(fontSAO.render(str, 1, (255, 255, 255)), (posx - fontSAO.size(str)[0] / 2, posy))

def printLine(pascalRow,posy):  # print a line of the pascal triangle
    interval = 100
    layer = len(pascalRow)
    for index in range(len(pascalRow)):
        printNum(str(pascalRow[index]),WindowWidth/2 - (layer-1)*interval/2 + index*interval,posy)

def getNextLine(pascalRow):     # work out the next line of the pascal triangle
    output = [1]
    for index in range(len(pascalRow)-1):
        output.append(pascalRow[index]+pascalRow[index+1])
    output.append(1)
    return output

pascal = [1] # first line
layer = 1
offset = 20
interval = fontSAO.size('0')[1]+20
printLine(pascal,offset)
pygame.display.flip()
#display initialization
temp = None
while True:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit() #Input detection
        if pygame.key.get_pressed()[pygame.K_SPACE]: # display the next line when [SPACE] is pressed
            if layer*interval < WindowHeight - 2*offset:
                pascal = getNextLine(pascal)
                printLine(pascal,offset+layer*interval)
                pygame.display.flip()
                layer += 1
            else:
                temp = canvas.copy()
                canvas.blit(bg,(0,0))
                canvas.blit(temp,(0,-interval))
                pascal = getNextLine(pascal)
                printLine(pascal,offset+(layer - 1)*interval)
                pygame.display.flip()
                                        # basically you can have as much lines as you want
                                        # however the length of the lines will go out of the display
                                        # and the numbers getting longer will overlap each other
        if pygame.key.get_pressed()[pygame.K_RETURN]:   # reset the display when [RETURN] is pressed
            canvas.blit(bg,(0,0))
            pascal = [1]
            layer = 1
            temp = None
            printLine(pascal,offset)
            pygame.display.flip()


# HOW TO USE:
# Press Space to show the next line
# Press Enter to reset the Pascal Triangle
