import pygame
import os
import math
import random
import time
from Sprite import *
pygame.init()

listFlower = list()
setFlowerPos = set()
#universal variables for functions

class sakura(Sprite): # sakura flower sprite on the tree
    timeRemain = 0
    fallTime = 0
    fallSpeed = 0
    layTime = 0
    originalPos = None
    def __init__(self,pos):
        Sprite.__init__(self,pos)
        self.timeRemain = 0
        self.fallTime = 0
        self.fallSpeed = 0
        self.layTime = 0
    def setTimeRemain(self,time):	# when TimeRemain = 0, the flower will start to fall
        self.timeRemain = time
        self.originalPos = (self.position[0]+8,self.position[1]+8)
    def doFrame(self,screen):		# call this every frame
        if self.timeRemain > 0:
            self.timeRemain -= 1
            self.show(screen)
        elif self.position[1] < 747:
            self.fallTime += 1
            self.fallSpeed = int(self.fallTime**1.2)
            self.move((int(self.fallSpeed*random.gauss(0.3,0.1)),self.fallSpeed))
            self.show(screen)
        else:
            self.layTime += 1
            self.show(screen)

def paintBranch(x1,y1,angle,length,width,color): #paint a branch line and return the end point
    lenR = length * random.gauss(1, 0.3)
    x2 = int(x1 + lenR * math.cos(math.radians(angle)))
    y2 = int(y1 + lenR * math.sin(math.radians(angle)))
    pygame.draw.line(canvas,color,(x1,y1),(x2,y2),width)
    return x2,y2

def addFlower(x,y):	#add a flower at the given position(center), return the sprite
    flower = sakura((x,y))
    flower.setImage(sakuraPic)
    flower.move((-8,-8))
    flower.setTimeRemain(2+random.randrange(0,50))
    return flower

def paintTree(x0,y0,layer,deltaAngle = 0):	#call this to paint a complete tree
    newBranch = False
    if layer == 1 and not (x0,y0) in setFlowerPos:
        f = addFlower(x0,y0)
        listFlower.append(f)
        setFlowerPos.add((x0,y0))
        return
    elif layer <= 3 and not (x0,y0) in setFlowerPos:
        rate = random.random()
        if rate < layer*0.3:
            f = addFlower(x0,y0)
            listFlower.append(f)
            setFlowerPos.add((x0, y0))
        newBranch = True
    length = 12*layer
    if layer >= 4:
        width = -4+layer*2
    else:
        width = layer
    dAngle = 5 + 2*layer+random.randrange(0,7)
    branchBrown = (58-layer*4,46-layer*3,32-layer*2)
    x1,y1 = paintBranch(x0,y0,-90+deltaAngle,length,width,branchBrown)
    pygame.display.flip()
    rate = random.random()

    if layer >= 5 or (layer < 5 and rate < 0.7+0.05*layer):
        paintTree(x1, y1, layer - 1, deltaAngle-dAngle)
        newBranch = True
    rate = random.random()
    if layer >= 5 or (layer < 5 and rate < 0.7+0.05*layer):
        paintTree(x1, y1, layer - 1, deltaAngle+dAngle)
        newBranch = True
    if not newBranch and not (x1,y1) in setFlowerPos:
        f = addFlower(x1,y1)
        listFlower.append(f)
        setFlowerPos.add((x1, y1))

def startFall():	#call this to start the falling countdown
    for flower in listFlower:
        flower.visible = True

def mainFrame():	#main function for every frame
    canvas.blit(fallBG,(0,0))
    for flower in listFlower:
        indexF = listFlower.index(flower)
        flower.doFrame(canvas)
        if flower.layTime > 50 and flower.visible:
            flower.visible = False
        if flower.layTime > 60:
            newF = addFlower(flower.originalPos[0],flower.originalPos[1])
            newF.visible = True
            listFlower.pop(indexF)
            listFlower.append(newF)
    pygame.display.update()
    pygame.time.delay(100)
    #Framerate:10fps or lower

pygame.display.set_mode((1200,800))	#resolution
pygame.display.set_caption('H5-tree')	#title
sakuraPic = pygame.image.load(os.path.join('','sakura.png'))	#flower picture, 16x16
icon = pygame.image.load(os.path.join('','icon.png'))	#window icon, 16x16
background = pygame.image.load(os.path.join('','bg.png'))	#background, 1200x800
pygame.display.set_icon(icon)
canvas = pygame.display.get_surface()
canvas.blit(background,(0,0))
#Window initialization

paintTree(600,750,9)
pygame.display.flip()
fallBG = canvas.copy()

startFall()
while True:	#loop
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit() #Input detection
    mainFrame()
